#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "bmpstruct.h"

void writersbfooter (FILE *ofile)
{
  unsigned char temp;
  char czero=0;
  int izero=0;

  fwrite(&izero, sizeof(int), 1, ofile);
  temp=1;
  fwrite(&temp, sizeof(char), 1, ofile);
  fwrite(&izero, sizeof(int), 1, ofile);
  fwrite(&izero, sizeof(int), 1, ofile);
  fwrite(&czero, sizeof(char), 1, ofile);
  fwrite(&czero, sizeof(char), 1, ofile);
  temp=2;
  fwrite(&temp, sizeof(char), 1, ofile);
  fwrite(&czero, sizeof(char), 1, ofile);
  fwrite(&czero, sizeof(char), 1, ofile);
  fwrite(&czero, sizeof(char), 1, ofile);
  temp=3;
  fwrite(&temp, sizeof(char), 1, ofile);
  fwrite(&izero, sizeof(int), 1, ofile);
  fwrite(&izero, sizeof(int), 1, ofile);
  fwrite(&izero, sizeof(int), 1, ofile);
  fwrite(&izero, sizeof(int), 1, ofile);
  fwrite(&izero, sizeof(int), 1, ofile);
  fwrite(&izero, sizeof(int), 1, ofile);
  fwrite(&izero, sizeof(int), 1, ofile);
  fwrite(&izero, sizeof(int), 1, ofile);
  fwrite(&izero, sizeof(int), 1, ofile);
  fwrite(&izero, sizeof(int), 1, ofile);
  fwrite(&czero, sizeof(char), 1, ofile);
  temp=255;
  fwrite(&temp, sizeof(char), 1, ofile);
  fwrite(&temp, sizeof(char), 1, ofile);
  fwrite(&temp, sizeof(char), 1, ofile);
  fwrite(&temp, sizeof(char), 1, ofile);
  
}

void initheaders (bitmapheader *Header, bitmapinfoheader *Info,
		  int Width, int Height)
{
  Header->Signature[0]='B';
  Header->Signature[1]='M';
  Header->FileSize = (Width*Height*3)+14+40;
  Header->reserved = 0;
  Header->DataOffset = 14+40;

  Info->Size = 40;
  Info->Width = Width;
  Info->Height = Height;
  Info->Planes = 1;
  Info->BitCount = 24;
  Info->Compression = 0;
  Info->ImageSize = 0;
  Info->XpixelsPerM = 0;
  Info->YpixelsPerM = 0;
  Info->ColorsUsed = 0;
  Info->ColorsImportant = 0;
}

void rsb2bmp(FILE *ifile, FILE *ofile, int alpha)
{
  bitmapheader Header;
  bitmapinfoheader Info;
  int i, c, data;
  long lines=0;
  int height;
  int r, g, b, a;
  int bpp;
  short bitmapbpp;
  int width;
  unsigned char red, green, blue;
  unsigned char temp[4];
  int rowlength;
  int extradata;
  char extra[3] = {0,0,0};

  fread(&i, sizeof(int), 1, ifile);     //rsb version
  fread(&data, sizeof(int), 1, ifile);  //width
  width = data;
  fread(&data, sizeof(int), 1, ifile);  //height
  height = data;
  fread(&r, sizeof(int), 1, ifile);
  fread(&g, sizeof(int), 1, ifile);
  fread(&b, sizeof(int), 1, ifile);
  fread(&a, sizeof(int), 1, ifile);
  bpp=r+g+b+a;
  bitmapbpp=r+g+b;
  initheaders(&Header, &Info, width, height);
//  fwrite(&Header, sizeof(bitmapheader), 1, ofile);  //windows has a problem with this
  fwrite(&Header.Signature, sizeof(char), 2, ofile);
  fwrite(&Header.FileSize, sizeof(int), 1, ofile);
  fwrite(&Header.reserved, sizeof(int), 1, ofile);
  fwrite(&Header.DataOffset, sizeof(int), 1, ofile);
  fwrite(&Info, sizeof(bitmapinfoheader), 1, ofile);
  rowlength = width * (bitmapbpp/8);
  extradata = 4-(rowlength%4);
  if(extradata==4)
    extradata = 0;
  rowlength += extradata;
  for(i=0;i<height;i++)                               //for loop to make the file the right
  {                                                   //  size.  There's prolly a better way
    for(c=0;c<width;c++)
    {
	  fwrite(&extra, sizeof(char), 1, ofile);
	  fwrite(&extra, sizeof(char), 1, ofile);
	  fwrite(&extra, sizeof(char), 1, ofile);
    }
    fwrite(&extra, sizeof(char), extradata, ofile);
  }
  for(i=0;i<height;i++)
  {
    fseek(ofile, ((height-i)*rowlength)+54, SEEK_SET);
    for(c=0;c<width;c++)
	{
	  fread(&temp, sizeof(char), (bpp/8), ifile);
	  if(alpha)
	     temp[1] = temp[2] = temp[3] = temp[0];
	  red=temp[0];
	  green=temp[1];
	  blue=temp[2];
	  if(a)
	  {
	    blue=temp[1];
	    green=temp[2];
	    red=temp[3];
	  }
      lines++;
	  fwrite(&red, sizeof(char), 1, ofile);
	  fwrite(&green, sizeof(char), 1, ofile);
	  fwrite(&blue, sizeof(char), 1, ofile);
	}
  }
}

void bmp2rsb(FILE *ifile, FILE *ofile)
{
  bitmapheader Header;
  bitmapinfoheader Info;
  int i, c;
  long lines=0;
  int height;
  int r, g, b, a;
  int width;
  unsigned char red, green, blue;
  unsigned char temp[3];
  int rowlength;
  int extradata;

  i=6;
  fwrite(&i, sizeof(int), 1, ofile);     //rsb version
  fread(&Header.Signature, sizeof(char), 2, ifile);
  fread(&Header.FileSize, sizeof(int), 1, ifile);
  fread(&Header.reserved, sizeof(int), 1, ifile);
  fread(&Header.DataOffset, sizeof(int), 1, ifile);
  fread(&Info, sizeof(bitmapinfoheader), 1, ifile);

  fwrite(&Info.Width, sizeof(int), 1, ofile);  //width
  width = Info.Width;
  fwrite(&Info.Height, sizeof(int), 1, ofile);  //height
  height = Info.Height;
  r=g=b=8;
  a=0;
  fwrite(&r, sizeof(int), 1, ofile);
  fwrite(&g, sizeof(int), 1, ofile);
  fwrite(&b, sizeof(int), 1, ofile);
  fwrite(&a, sizeof(int), 1, ofile);
  rowlength = width * 3;
  extradata = 4-(rowlength%4);
  if(extradata==4)
    extradata = 0;
  rowlength += extradata;
  for(i=0;i<height;i++)
  {
    fseek(ifile, ((height-i)*rowlength)+54, SEEK_SET);
    for(c=0;c<width;c++)
	{
	  fread(&temp, sizeof(char), 3, ifile);
	  red=temp[0];
	  green=temp[1];
	  blue=temp[2];
      lines++;
	  fwrite(&red, sizeof(char), 1, ofile);
	  fwrite(&green, sizeof(char), 1, ofile);
	  fwrite(&blue, sizeof(char), 1, ofile);
	}
  }
  fseek(ofile, 0, SEEK_END);
  writersbfooter (ofile);
}

int main (int argc, char *argv[])
{
  FILE *ifile;
  FILE *ofile;
  char args[1000][1000];
  char ctype[2];
  int itype;
  char *ptr;
  int i;
  int argsc=0, alpha=0;
  char *newfile;

  if(argc<2)
    return 0;
  for(i=0;i<argc;i++)
  {
	if(argv[i][0]=='-')
	  strcpy(args[argsc++], argv[i]);
  }
  if(bsearch("-a", args[0], argsc, sizeof(char)*1024, strcmp))
	alpha=1;
  for(i=1;i<argc;i++)
  {
	if(argv[i][0]=='-')
	  continue;
    ifile = fopen(argv[i], "rb");
    if(!ifile)
      {
	printf("Error! Could not open input file: %s\n", argv[i]);
	continue;
      }
    printf("old file: %s\n", argv[i]);
    fflush(stdout);
    newfile=(char*)malloc(strlen(argv[i])+4);
    strcpy(newfile, argv[i]);
    ptr = strrchr(newfile, '.');
    if(!ptr)
      continue;
    if(!strcmp(ptr, ".rsb"))
      strcpy(ptr, ".bmp");
    else
      strcpy(ptr, ".rsb");
    printf("new file: %s\n\n", newfile);
    fread(&ctype, sizeof(char), 2, ifile);
    fseek(ifile, 0, SEEK_SET);
    fread(&itype, sizeof(int), 1, ifile);
    fseek(ifile, 0, SEEK_SET);
    if(ctype[0]=='B' && ctype[1]=='M')
      {
	ofile = fopen(newfile, "wb");
	if(!ofile)
	  {
	    printf("Error! Could not open output file: %s\n", newfile);
	    continue;
	  }
	bmp2rsb(ifile, ofile);
	fclose(ofile);
      }
    else if(itype==6)
      {
	ofile = fopen(newfile, "wb");
	if(!ofile)
	  {
	    printf("Error! Could not open output file: %s\n", newfile);
	    continue;
	  }
	rsb2bmp(ifile, ofile, alpha);
	fclose(ofile);
      }
    else
      {
	fclose(ifile);
	continue;
      }
    fclose(ifile);
  }

  return 1;
}
